QGIS Application - Bug report #21269

Python3 error when running GRASS 7.6 tools in processing on mac OS

2019-02-14 01:53 PM - Alejandro Garcia

Status: Open

Priority: High

Assignee: William Kyngesburye

Category: Processing/GRASS

Affected QGIS version:3.4.4 Regression?:

Operating System: macOS 10.14.3 Easy fix?:

Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 29087
Description

The Grass algorithm r.contour in the toolbox does not work and stop with an error message.

qgis 3.4.4 / grass 7.6 / macOS 10.14.3

History

#1 - 2019-02-18 02:35 PM - Giovanni Manghi
- Regression? changed from No to Yes
- Category changed from GRASS to Processing/GRASS

- Subject changed from GRASS algorithms in processing does not work (qgis 3.4.4 grass 7.6) to python error when running GRASS 7.6 tools in

processing on mac OS

Traceback (most recent call last):

File "/Applications/QGIS3.app/Contents/MacOS/grass/grass74", line 2029, in <module>

main()

File "/Applications/QGIS3.app/Contents/MacOS/grass/grass74", line 1880, in main
set_paths(grass_config_dir=grass_config_dir)

File "/Applications/QGIS3.app/Contents/MacOS/grass/grass74", line 622, in set_paths
os.environMANPATH'] = sys_man_path

File "/Library/Frameworks/Python.framework/Versions/3.6/lib/python3.6/0s.py", line 674, in setitem
value = self.encodevalue(value)

File "/Library/Frameworks/Python.framework/Versions/3.6/lib/python3.6/0s.py", line 744, in encode
raise TypeError("str expected, not %s" % type(value).__name__)

TypeError: str expected, not bytes

WARNING: Default locale settings are missing. GRASS running with C locale.

Default locale not found, using UTF-8

Traceback (most recent call last):

File "/Applications/QGIS3.app/Contents/MacOS/grass/grass74", line 2029, in <module>

main()

File "/Applications/QGIS3.app/Contents/MacOS/grass/grass74", line 1880, in main
set_paths(grass_config_dir=grass_config_dir)

File "/Applications/QGIS3.app/Contents/MacOS/grass/grass74", line 622, in set_paths
os.environMANPATH'] = sys_man_path

File "/Library/Frameworks/Python.framework/Versions/3.6/lib/python3.6/0s.py", line 674, in setitem
value = self.encodevalue(value)

File "/Library/Frameworks/Python.framework/Versions/3.6/lib/python3.6/0s.py", line 744, in encode
raise TypeError("str expected, not %s" % type(value).__name__)

TypeError: str expected, not bytes
Execution completed in 2.52 seconds

Results:{'output’: <QgsProcessingOutputLayerDefinition {'sink"./contours_alaska.shp, 'createOptions": {'fileEncoding": 'System'}}>}

Loading resulting layers
The following layers were not correctly generated.<ul><li>/contours_alaska.shp</li></ul>You can check the 'Log Messages Panel' in QGIS main window
to find more information about the execution of the algorithm.

#2 - 2019-02-21 12:29 PM - Peter Petrik
- Assignee set to William Kyngesburye

The issue is caused by grass76 bug in retrieving MANPATH directly by calling ‘'manpath® command in submodule. This should be probably fixed in next
GRASS release (fully compatible with python3).

As a workaround it should be enough to set environment variable

“export MANPATH=/usr/local/share/man:/usr/share/man’ in QGIS startup script or environment.

The bug is not present in unofficial all-in-one MacOS packages https://lutraconsulting.github.io/qgis-mac-packager/ as the workaround was applied in

https://github.com/lutraconsulting/qgis-mac-packager/issues/50

#3 - 2019-02-21 12:30 PM - Peter Petrik
- Subject changed from python error when running GRASS 7.6 tools in processing on mac OS to Python3 error when running GRASS 7.6 tools in

processing on mac OS

#4 - 2019-02-22 03:27 AM - William Kyngesburye

I'm not sure what your workaround is, | couldn't find anything in that mac packager issue. | think I'll try patching my bundled grass74 to set the MANPATH.

| won't be able to test it - | don't have macOS Mojave, and | don't have this problem on Sierra.

Files
Log Grass r.contours.rtf 5.36 KB 2019-02-14 Alejandro Garcia
Screen Shot 2019-02-13 at 9.11.12 AM_2.png 591 KB 2019-02-14 Alejandro Garcia
